# abra

[![Build Status](https://drone.autonomic.zone/api/badges/coop-cloud/abra/status.svg)](https://drone.autonomic.zone/coop-cloud/abra)
[![codecov](https://codecov.io/gh/Autonomic-Cooperative/abra/branch/main/graph/badge.svg?token=aX3I5NMRsj)](undefined)

> https://cloud.autonomic.zone

The cooperative cloud utility belt 🎩🐇

`abra` is a command-line tool for managing your own [Co-op Cloud](https://cloud.autonomic.zone). It can provision new servers, create applications, deploy them, run backup and restore operations and a whole lot of other things. It is the go-to tool for day-to-day operations when managing a Co-op Cloud instance.

## Change log

See [CHANGELOG.md](./CHANGELOG.md).

## Documentation

> [docs.cloud.autonomic.zone](https://docs.cloud.autonomic.zone/)

## Install

Install the latest stable release:

```sh
curl https://install.abra.autonomic.zone | bash
```

or the bleeding-edge development version:

```sh
curl https://install.abra.autonomic.zone | bash -s -- --dev
```

The source for this script is [here](./installer/installer).

## Update

Run `abra upgrade` to automatically download and install the latest release
version.

To update the development version, run

```sh
cd ~/.abra/src
git pull
```

## Hack

It's written in Bash version 4 or greater! Just open up the `abra` file and start hacking. Then you can run it in place with `./abra`. The command-line interface is generated via [docopt](http://docopt.org/). If you add arguments then you need to run `make docopt` ro regenerate the parser.

Please remember to update the [CHANGELOG](./CHANGELOG.md) when you make a change.

To deploy a new version of the installer scripts:

```sh
make release-installer
```
